import router from "../router.mjs";
import sql from "../sql.mjs";
import tpl from "../tpl.mjs";

tpl.readdir("views");

router.get(/^\/tags(\/\w+)?/, async (req, res) => {
  try {
    const tag = req.url;

    console.log(tag);

    return res.reply({ body: "wip" });
    const total = (await sql.query("select count(*) as total from items" + (mime ? q : "")))[0].total;
    const limit = 299;
    const pages = +Math.ceil(total / limit);
    const page = Math.min(pages, +req.url.split[mime ? 2 : 1] || 1);
    const offset = (page - 1) * limit;

    const query = await sql.query(`select id, mime from items ${mime ? q : ""} order by id desc limit ?, ?`, [ offset, limit ]);

    let cheat = [];
    for(let i = Math.max(1, page - 3); i <= Math.min(page + 3, pages); i++)
      cheat.push(i);

    query.forEach(e => {
      if(!fs.existsSync(`public/t/${e.id}.png`))
        fs.copyFileSync("public/s/img/broken.png", `public/t/${e.id}.png`);
    });

    const data = {
      items: query,
      pagination: {
        start: 1,
        end: pages,
        prev: (page > 1) ? page - 1 : null,
        next: (page < pages) ? page + 1 : null,
        page: page,
        cheat: cheat,
        link: `/${mime ? mime + "/" : ""}p/`
      },
      last: query[query.length - 1].id,
      filter: mime ? mime : undefined
    };

    res.reply({ body: tpl.render("views/index", data) });
  } catch(err) {
    console.log(err);
    res.reply({ body: "sorry bald wieder da lol :(" });
  }
});